// Code generated by go-swagger; DO NOT EDIT.

package events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new events API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for events API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetEventHistory(params *GetEventHistoryParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetEventHistoryOK, error)

	GetEventListeners(params *GetEventListenersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetEventListenersOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetEventHistory gets events history

  Get recent events history.

*/
func (a *Client) GetEventHistory(params *GetEventHistoryParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetEventHistoryOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetEventHistoryParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getEventHistory",
		Method:             "GET",
		PathPattern:        "/api/namespaces/{namespace}/events",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetEventHistoryReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetEventHistoryOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getEventHistory: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetEventListeners gets current event listeners

  Get current event listeners.

*/
func (a *Client) GetEventListeners(params *GetEventListenersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetEventListenersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetEventListenersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getEventListeners",
		Method:             "GET",
		PathPattern:        "/api/namespaces/{namespace}/event-listeners",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetEventListenersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetEventListenersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getEventListeners: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
