// Code generated by go-swagger; DO NOT EDIT.

package namespace_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"fmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// CreateNamespaceServiceReader is a Reader for the CreateNamespaceService structure.
type CreateNamespaceServiceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateNamespaceServiceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateNamespaceServiceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateNamespaceServiceOK creates a CreateNamespaceServiceOK with default headers values
func NewCreateNamespaceServiceOK() *CreateNamespaceServiceOK {
	return &CreateNamespaceServiceOK{}
}

/* CreateNamespaceServiceOK describes a response with status code 200, with default header values.

successfully created service
*/
type CreateNamespaceServiceOK struct {
}

func (o *CreateNamespaceServiceOK) Error() string {
	return fmt.Sprintf("[POST /api/functions/namespaces/{namespace}][%d] createNamespaceServiceOK ", 200)
}

func (o *CreateNamespaceServiceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

/*CreateNamespaceServiceBody create namespace service body
// Example: {"cmd":"","image":"direktiv/request:v12","minScale":"1","name":"fast-request","size":"small"}
swagger:model CreateNamespaceServiceBody
*/
type CreateNamespaceServiceBody struct {

	// cmd
	// Required: true
	Cmd *string `json:"cmd"`

	// Target image a service will use
	// Required: true
	Image *string `json:"image"`

	// Minimum amount of service pods to be live
	// Required: true
	MinScale *int64 `json:"minScale"`

	// Name of new service
	// Required: true
	Name *string `json:"name"`

	// Size of created service pods
	// Required: true
	// Enum: [small medium large]
	Size *string `json:"size"`
}

// Validate validates this create namespace service body
func (o *CreateNamespaceServiceBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCmd(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateImage(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateMinScale(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *CreateNamespaceServiceBody) validateCmd(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"cmd", "body", o.Cmd); err != nil {
		return err
	}

	return nil
}

func (o *CreateNamespaceServiceBody) validateImage(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"image", "body", o.Image); err != nil {
		return err
	}

	return nil
}

func (o *CreateNamespaceServiceBody) validateMinScale(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"minScale", "body", o.MinScale); err != nil {
		return err
	}

	return nil
}

func (o *CreateNamespaceServiceBody) validateName(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"name", "body", o.Name); err != nil {
		return err
	}

	return nil
}

var createNamespaceServiceBodyTypeSizePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["small","medium","large"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		createNamespaceServiceBodyTypeSizePropEnum = append(createNamespaceServiceBodyTypeSizePropEnum, v)
	}
}

const (

	// CreateNamespaceServiceBodySizeSmall captures enum value "small"
	CreateNamespaceServiceBodySizeSmall string = "small"

	// CreateNamespaceServiceBodySizeMedium captures enum value "medium"
	CreateNamespaceServiceBodySizeMedium string = "medium"

	// CreateNamespaceServiceBodySizeLarge captures enum value "large"
	CreateNamespaceServiceBodySizeLarge string = "large"
)

// prop value enum
func (o *CreateNamespaceServiceBody) validateSizeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, createNamespaceServiceBodyTypeSizePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (o *CreateNamespaceServiceBody) validateSize(formats strfmt.Registry) error {

	if err := validate.Required("Service"+"."+"size", "body", o.Size); err != nil {
		return err
	}

	// value enum
	if err := o.validateSizeEnum("Service"+"."+"size", "body", *o.Size); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this create namespace service body based on context it is used
func (o *CreateNamespaceServiceBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *CreateNamespaceServiceBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *CreateNamespaceServiceBody) UnmarshalBinary(b []byte) error {
	var res CreateNamespaceServiceBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
