// Code generated by go-swagger; DO NOT EDIT.

package namespaces

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteNamespaceParams creates a new DeleteNamespaceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteNamespaceParams() *DeleteNamespaceParams {
	return &DeleteNamespaceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteNamespaceParamsWithTimeout creates a new DeleteNamespaceParams object
// with the ability to set a timeout on a request.
func NewDeleteNamespaceParamsWithTimeout(timeout time.Duration) *DeleteNamespaceParams {
	return &DeleteNamespaceParams{
		timeout: timeout,
	}
}

// NewDeleteNamespaceParamsWithContext creates a new DeleteNamespaceParams object
// with the ability to set a context for a request.
func NewDeleteNamespaceParamsWithContext(ctx context.Context) *DeleteNamespaceParams {
	return &DeleteNamespaceParams{
		Context: ctx,
	}
}

// NewDeleteNamespaceParamsWithHTTPClient creates a new DeleteNamespaceParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteNamespaceParamsWithHTTPClient(client *http.Client) *DeleteNamespaceParams {
	return &DeleteNamespaceParams{
		HTTPClient: client,
	}
}

/* DeleteNamespaceParams contains all the parameters to send to the API endpoint
   for the delete namespace operation.

   Typically these are written to a http.Request.
*/
type DeleteNamespaceParams struct {

	/* Namespace.

	   target namespace to delete
	*/
	Namespace string

	/* Recursive.

	   recursively deletes all child resources
	*/
	Recursive *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete namespace params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNamespaceParams) WithDefaults() *DeleteNamespaceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete namespace params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNamespaceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete namespace params
func (o *DeleteNamespaceParams) WithTimeout(timeout time.Duration) *DeleteNamespaceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete namespace params
func (o *DeleteNamespaceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete namespace params
func (o *DeleteNamespaceParams) WithContext(ctx context.Context) *DeleteNamespaceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete namespace params
func (o *DeleteNamespaceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete namespace params
func (o *DeleteNamespaceParams) WithHTTPClient(client *http.Client) *DeleteNamespaceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete namespace params
func (o *DeleteNamespaceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the delete namespace params
func (o *DeleteNamespaceParams) WithNamespace(namespace string) *DeleteNamespaceParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the delete namespace params
func (o *DeleteNamespaceParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithRecursive adds the recursive to the delete namespace params
func (o *DeleteNamespaceParams) WithRecursive(recursive *bool) *DeleteNamespaceParams {
	o.SetRecursive(recursive)
	return o
}

// SetRecursive adds the recursive to the delete namespace params
func (o *DeleteNamespaceParams) SetRecursive(recursive *bool) {
	o.Recursive = recursive
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteNamespaceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	if o.Recursive != nil {

		// query param recursive
		var qrRecursive bool

		if o.Recursive != nil {
			qrRecursive = *o.Recursive
		}
		qRecursive := swag.FormatBool(qrRecursive)
		if qRecursive != "" {

			if err := r.SetQueryParam("recursive", qRecursive); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
