// Code generated by go-swagger; DO NOT EDIT.

package registries

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteGlobalRegistryParams creates a new DeleteGlobalRegistryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteGlobalRegistryParams() *DeleteGlobalRegistryParams {
	return &DeleteGlobalRegistryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteGlobalRegistryParamsWithTimeout creates a new DeleteGlobalRegistryParams object
// with the ability to set a timeout on a request.
func NewDeleteGlobalRegistryParamsWithTimeout(timeout time.Duration) *DeleteGlobalRegistryParams {
	return &DeleteGlobalRegistryParams{
		timeout: timeout,
	}
}

// NewDeleteGlobalRegistryParamsWithContext creates a new DeleteGlobalRegistryParams object
// with the ability to set a context for a request.
func NewDeleteGlobalRegistryParamsWithContext(ctx context.Context) *DeleteGlobalRegistryParams {
	return &DeleteGlobalRegistryParams{
		Context: ctx,
	}
}

// NewDeleteGlobalRegistryParamsWithHTTPClient creates a new DeleteGlobalRegistryParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteGlobalRegistryParamsWithHTTPClient(client *http.Client) *DeleteGlobalRegistryParams {
	return &DeleteGlobalRegistryParams{
		HTTPClient: client,
	}
}

/* DeleteGlobalRegistryParams contains all the parameters to send to the API endpoint
   for the delete global registry operation.

   Typically these are written to a http.Request.
*/
type DeleteGlobalRegistryParams struct {

	/* RegistryPayload.

	   Payload that contains registry data
	*/
	RegistryPayload DeleteGlobalRegistryBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete global registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteGlobalRegistryParams) WithDefaults() *DeleteGlobalRegistryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete global registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteGlobalRegistryParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete global registry params
func (o *DeleteGlobalRegistryParams) WithTimeout(timeout time.Duration) *DeleteGlobalRegistryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete global registry params
func (o *DeleteGlobalRegistryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete global registry params
func (o *DeleteGlobalRegistryParams) WithContext(ctx context.Context) *DeleteGlobalRegistryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete global registry params
func (o *DeleteGlobalRegistryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete global registry params
func (o *DeleteGlobalRegistryParams) WithHTTPClient(client *http.Client) *DeleteGlobalRegistryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete global registry params
func (o *DeleteGlobalRegistryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegistryPayload adds the registryPayload to the delete global registry params
func (o *DeleteGlobalRegistryParams) WithRegistryPayload(registryPayload DeleteGlobalRegistryBody) *DeleteGlobalRegistryParams {
	o.SetRegistryPayload(registryPayload)
	return o
}

// SetRegistryPayload adds the registryPayload to the delete global registry params
func (o *DeleteGlobalRegistryParams) SetRegistryPayload(registryPayload DeleteGlobalRegistryBody) {
	o.RegistryPayload = registryPayload
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteGlobalRegistryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.RegistryPayload); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
